TRACEROUTE(8)

NAME
traceroute - print the route packets trace to network host

SYNOPSIS
traceroute [-46dFITUnrAV] [-f first_ttl] [-g gate,...]
[-i device] [-m max_ttl] [-p port] [-s src_addr]
[-q nqueries] [-N squeries] [-t tos]
[-l flow_label] [-w waittime] [-z sendwait]
host [packetlen]
traceroute6 [options]
tracert [options]
tcptraceroute [options]

DESCRIPTION
traceroute tracks the route packets take across an IP network on their way to a given host. It utilizes the IP protocol's time to live (TTL) field and attempts to elicit an ICMP TIME_EXCEEDED response from each gateway along the path to the host.

traceroute6 equivalents to traceroute -6
tracert equivalents to traceroute -I
tcptraceroute equivalents to traceroute -T -p 80

OPTIONS
The only required parameter is the name or IP address of the destination host. This paremeter can be followed by the size of the probing packet sent to that host (40 by default). Varying the size of the packet in conjunction with the -F parameter can be used to obtain information about the MTU of individual network hops. (The size parameter is useless for TCP probes).

Additional options are:

--help
    Print help info and exit.

-4, -6
    Explicitly force IPv4 or IPv6 traceouting. By default, the program will try to resolve the name given, and choose the appropriate protocol automatically. If resolving a host name returns both IPv4 and IPv6 addresses, traceroute will use IPv4.

-I  Use ICMP ECHO for probes

-T  Use TCP SYN for probes

-U  Use UDP datagrams for probes (it is default). Only UDP method is allowed for unprivileged users.

-d  Enable socket level debugging (when the Linux kernel supports it)

-F  Set the "Don't Fragment" bit. This tells intermediate routers not to fragment the packet when they find it's too big for a network hop's MTU.

-f first_ttl
    Specifies with what TTL to start. Defaults to 1.

-g gateway
    Tells traceroute to add an IP source routing option to the outgoing packet that tells the network to route the packet through the specified gateway. Not very useful, because most routers have disabled source routing for security reasons.

-i interface
    Specifies the interface through which traceroute should send packets. By default, the interface is selected according to the routing table.

-m max_ttl
    Specifies the maximum number of hops (max time-to-live value) traceroute will probe. The default is 30.

-N squeries
    Specifies the number of probe packets sent out simultaneously. Sending several probes concurrently can speed up traceroute considerably. The default value is 15.
    Note that some routers and hosts can use ICMP rate throttling. In such a situation specifying too large number can lead to loss of some responses.

-n  Do not try to map IP addresses to host names when displaying them.

-p port
    For UDP tracing, specifies the destination port base traceroute will use (the destination port number will be incremented by each probe).
    For ICMP tracing, specifies the initial icmp sequence value (incremented by each probe too).
    For TCP specifies just the (constant) destination port to connect.

-t tos
    For IPv4, set the Type of Service (TOS) and Precedence value. Useful values are 16 (low delay) and 8 (high throughput). Note that in order to use some TOS precendence values, you have to be super user.
    For IPv6, set the Traffic Control value.

-w waittime
    Set the time (in seconds) to wait for a response to a probe (default 5.0 sec).

-q nqueries
    Sets the number of probe packets per hop. The default is 3.

-r  Bypass the normal routing tables and send directly to a host on an attached network. If the host is not on a directly-attached network, an error is returned. This option can be used to ping a local host through an interface that has no route through it.

-s source_addr
    Chooses an alternative source address. Note that you must select the address of one of the interfaces. By default, the address of the outgoing interface is used.

-z sendwait
    Minimal time interval between probes (default 0). If the value is more than 10, then it specifies a number in milliseconds, else it is a number of seconds (float point values allowed too). Useful when some routers use rate-limit for icmp messages.

-A  Perform AS path lookups in routing registries and print results directly after the corresponding addresses

-V  Print the version and exit.

This program attempts to trace the route an IP packet would follow to some internet host by launching a probe packets with a small ttl (time to live) then listening for an ICMP "time exceeded" reply from a gateway. We start our probes with a ttl of one and increase by one until we get an ICMP "port unreachable" (or TCP reset), which means we got to "host", or hit a max (which defaults to 30 hops). Three (by default) probes are sent at each ttl setting and a line is printed showing the ttl, address of the gateway and round trip time of each probe. If the probe answers come from different gateways, the address of each responding system will be printed. If there is no response within a 5.0 (default) seconds, a "*" is printed for that probe.

We don't want the destination host to process the UDP probe packets so the destination port is set to an unlikely value (you can change it with the -p flag). There is no such problem for ICMP or TCP tracerouting (for TCP we close sessions immediately after connect).

After the time some additional annotation can be printed: !H, !N, or !P (host, network or protocol unreachable), !S (source route failed), !F (fragmentation needed), !X (communication administratively prohibited), !V (host precedence violation), !C (precedence cutoff in effect), or !<num> (ICMP unreachable code <num>). If almost all the probes result in some kind of unreachable, traceroute will give up and exit.

SEE ALSO
ping(8), ping6(8), tracepath(8), netstat(8).